module aam;

private {
	import win32.ansi.windows;
	import nsmsgs.consts, nsmsgs.types;
	import std.string;
}

extern (C) {
	void gc_init();
	void gc_term();
	void _minit();
	void _moduleCtor();
	void _moduleUnitTests();
}

private const char[][] PluginInfo = [
	NSM_API_VERSION,                     // API Version
	"AddIn/aam",                         // Module Name
	"An Answering Machine on Regnessem", // Plugin Title
	"An Answering Machine on Regnessem", // Description
	"Moon",                              // Author
	"Copyright (c) 2004 Moon",           // Copyright
	"0.0.1",                             // Version
];

extern (Windows)
BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
	switch (ulReason) {
	case DLL_PROCESS_ATTACH:
		gc_init();          // init GC
		_minit();           // init module list
		_moduleCtor();      // run  module constructor
		_moduleUnitTests(); // run  unit test
		break;
	case DLL_PROCESS_DETACH:
		gc_term();
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		// multi-thread is not supported
		return FALSE;
	}
	return TRUE;
}

// DLL Export Functions

extern (Windows)
int GetPluginInfo(int nInfoNo, LPTSTR lpBuffer, int nSize)
{
	if (nInfoNo < 0 || nInfoNo > PluginInfo.length) {
		// Unknown Information Number
		return 0;
	} else {
		lstrcpyn(lpBuffer, toStringz(PluginInfo[nInfoNo]), nSize);
		return lstrlen(lpBuffer);
	}
}

extern (Windows)
int Initialize(PNsmPluginInitInfo lpInitInfo)
{
	return 0;
}

extern (Windows)
int Terminate()
{
	return 0;
}
